import React from 'react';
import defaultOptions from '../../defaultOptions';
import { ActionType } from '../../enums';
import { getGroupText, updateExpandedGroups } from '../../Utils/GroupUtils';
import EmptyCells from '../EmptyCells/EmptyCells';
var GroupRow = function (_a) {
    var columns = _a.columns, emptyColumnsCount = _a.emptyColumnsCount, groupRowData = _a.groupRowData, groupedColumns = _a.groupedColumns, groups = _a.groups, groupsExpanded = _a.groupsExpanded, dispatch = _a.dispatch;
    var group = groups && groups[emptyColumnsCount];
    var column = group && groupedColumns.find(function (c) { return c.key === group.columnKey; });
    return (React.createElement("tr", { className: defaultOptions.css.groupRow },
        React.createElement(EmptyCells, { count: emptyColumnsCount }),
        React.createElement("td", { className: 'ka-group-column', colSpan: columns.length - emptyColumnsCount + groups.length },
            React.createElement("div", { className: 'ka-group-column-content' },
                React.createElement("div", { onClick: function () {
                        var updatedGroupsExpanded = updateExpandedGroups(groupsExpanded, groupRowData);
                        dispatch(ActionType.UpdateGroupsExpanded, { newValue: { groupsExpanded: updatedGroupsExpanded } });
                    }, className: groupsExpanded.some(function (ge) { return JSON.stringify(ge) === JSON.stringify(groupRowData.key); })
                        ? defaultOptions.css.iconGroupArrowExpanded : defaultOptions.css.iconGroupArrowCollapsed }),
                React.createElement("div", { className: 'ka-group-text' }, getGroupText(groupRowData.value, column))))));
};
export default GroupRow;