var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { DataType } from '../enums';
import { getField } from './ColumnUtils';
import { getValueByColumn, replaceValue } from './DataUtils';
export var convertToColumnTypes = function (data, columns) {
    var newData = data.map(function (d) {
        var nd = __assign({}, d);
        columns.forEach(function (c) {
            var field = getField(c);
            if (nd[field] != null) {
                switch (c.dataType) {
                    case DataType.String:
                        nd = replaceValue(nd, c, getValueByColumn(nd, c).toString());
                        break;
                    case DataType.Number:
                        nd = replaceValue(nd, c, Number(getValueByColumn(nd, c)));
                        break;
                    case DataType.Date:
                        nd = replaceValue(nd, c, new Date(getValueByColumn(nd, c)));
                        break;
                    case DataType.Boolean:
                        nd = replaceValue(nd, c, toBoolean(getValueByColumn(nd, c)));
                        break;
                }
            }
        });
        return nd;
    });
    return newData;
};
export var getColumnsWithWrongType = function (data, columns) {
    if (!data.length) {
        return [];
    }
    var item = data[0];
    var columnsWithWrongType = columns.filter(function (c) {
        var field = getField(c);
        var value = item[field];
        if (value != null) {
            switch (c.dataType) {
                case DataType.String: return value.constructor !== String;
                case DataType.Number: return value.constructor !== Number;
                case DataType.Date: return value.constructor !== Date;
                case DataType.Boolean: return value.constructor !== Boolean;
                case DataType.Object: return value.constructor !== Object;
            }
        }
        return true;
    });
    return columnsWithWrongType;
};
export var toBoolean = function (value) {
    if (typeof value === 'string') {
        switch (value.toLowerCase().trim()) {
            case 'true':
            case 'yes':
            case '1': return true;
            case 'false':
            case 'no':
            case '0':
            case null: return false;
        }
    }
    return Boolean(value);
};
export function isFunction(variableToCheck) {
    if (variableToCheck instanceof Function) {
        return true;
    }
    return false;
}